## glances 4.3.1+dfsg

=== Makefile ===
PORT     ?= 8008
venv_full:= venv/bin
venv_min := venv-min/bin
CONF     := conf/glances.conf
PIP      := $(venv_full)/pip
PYTHON   := $(venv_full)/python
PYTEST   := $(venv_full)/python -m pytest
LASTTAG  = $(shell git describe --tags --abbrev=0)

VENV_TYPES    := full min
VENV_PYTHON   := $(VENV_TYPES:%=venv-%-python)
VENV_UPG      := $(VENV_TYPES:%=venv-%-upgrade)
VENV_DEPS     := $(VENV_TYPES:%=venv-%)
VENV_INST_UPG := $(VENV_DEPS) $(VENV_UPG)

IMAGES_TYPES      := full minimal
DISTROS           := alpine ubuntu
alpine_images     := $(IMAGES_TYPES:%=docker-alpine-%)
ubuntu_images     := $(IMAGES_TYPES:%=docker-ubuntu-%)
DOCKER_IMAGES     := $(alpine_images) $(ubuntu_images)
DOCKER_RUNTIMES   := $(DOCKER_IMAGES:%=run-%)
UNIT_TESTS        := test-core test-restful test-xmlrpc
DOCKER_BUILD      := docker buildx build
DOCKER_RUN        := docker run
PODMAN_SOCK       ?= /run/user/$(shell id -u)/podman/podman.sock
DOCKER_SOCK       ?= /var/run/docker.sock
DOCKER_SOCKS      := -v $(PODMAN_SOCK):$(PODMAN_SOCK):ro -v $(DOCKER_SOCK):$(DOCKER_SOCK):ro
DOCKER_OPTS       := --rm -e TZ="${TZ}" -e GLANCES_OPT="" --pid host --network host

# if the command is only `make`, the default tasks will be the printing of the help.
.DEFAULT_GOAL := help

.PHONY: help test docs docs-server venv venv-min

help: ## List all make commands available
	@grep -E '^[\.a-zA-Z_%-]+:.*?## .*$$' $(MAKEFILE_LIST) | \
	awk -F ":" '{print $1}' | \
	grep -v % | \
	sed 's/\\//g' | \
	sort | \
	awk 'BEGIN {FS = ":[^:]*?##"}; {printf "\033[1;34mmake %-50s\033[0m %s\n", $$1, $$2}'

# ===================================================================
# Virtualenv
# ===================================================================

venv-%-upgrade: UPGRADE = --upgrade

define DEFINE_VARS_FOR_TYPE
venv-$(TYPE) venv-$(TYPE)-upgrade: VIRTUAL_ENV = $(venv_$(TYPE))
endef

$(foreach TYPE,$(VENV_TYPES),$(eval $(DEFINE_VARS_FOR_TYPE)))

$(VENV_PYTHON): venv-%-python:
	virtualenv -p python3 $(if $(filter full,$*),venv,venv-$*)

$(VENV_INST_UPG): venv-%:
	$(if $(UPGRADE),$(VIRTUAL_ENV)/pip install --upgrade pip,)
	$(foreach REQ,$(REQS), $(VIRTUAL_ENV)/pip install $(UPGRADE) -r $(REQ);)
	$(if $(PRE_COMMIT),$(VIRTUAL_ENV)/pre-commit install --hook-type pre-commit,)

venv-python: $(VENV_PYTHON) ## Install all Python 3 venv
venv: $(VENV_DEPS) ## Install all Python 3 dependencies
venv-upgrade: $(VENV_UPG) ## Upgrade all Python 3 dependencies

# For full installation (with optional dependencies)

venv-full venv-full-upgrade: REQS = requirements.txt optional-requirements.txt dev-requirements.txt doc-requirements.txt

venv-full-python: ## Install Python 3 venv
venv-full: venv-python ## Install Python 3 run-time
venv-full-upgrade: ## Upgrade Python 3 run-time dependencies
venv-full: PRE_COMMIT = 1

# For minimal installation (without optional dependencies)

venv-min venv-min-upgrade: REQS = requirements.txt dev-requirements.txt doc-requirements.txt

venv-min-python: ## Install Python 3 venv minimal
venv-min: venv-min-python ## Install Python 3 minimal run-time dependencies
venv-min-upgrade: ## Upgrade Python 3 minimal run-time dependencies

# ===================================================================
# Tests
# ===================================================================

test: ## Run All unit tests
	$(PYTEST)

test-core: ## Run Core unit tests
	$(PYTEST) tests/test_core.py

test-memoryleak: ## Run Memory-leak unit tests
	$(PYTEST) tests/test_memoryleak.py

test-perf: ## Run Perf unit tests
	$(PYTEST) tests/test_perf.py

test-restful: ## Run Restful API unit tests
	$(PYTEST) tests/test_restful.py

test-webui: ## Run WebUI unit tests
	$(PYTEST) tests/test_webui.py

test-xmlrpc: ## Run XMLRPC API unit tests
	$(PYTEST) tests/test_xmlrpc.py

test-with-upgrade: venv-upgrade test ## Upgrade deps and run unit tests

test-min: ## Run core unit tests in minimal environment
	$(venv_min)/python -m pytest tests/test_core.py

test-min-with-upgrade: venv-min-upgrade ## Upgrade deps and run unit tests in minimal environment
	$(venv_min)/python -m pytest tests/test_core.py

# ===================================================================
# Linters, profilers and cyber security
# ===================================================================

format: ## Format the code
	$(venv_full)/python -m ruff format .

lint: ## Lint the code.
	$(venv_full)/python -m ruff check . --fix

codespell: ## Run codespell to fix common misspellings in text files
	$(venv_full)/codespell -S .git,./docs/_build,./Glances.egg-info,./venv*,./glances/outputs,*.svg -L hart,bu,te,statics -w

semgrep: ## Run semgrep to find bugs and enforce code standards
	$(venv_full)/semgrep scan --config=auto

profiling-%: SLEEP = 3
profiling-%: TIMES = 30
profiling-%: OUT_DIR = docs/_static

define DISPLAY-BANNER
@echo "Start Glances for $(TIMES) iterations (more or less 1 mins, please do not exit !)"
sleep $(SLEEP)
endef

profiling-gprof: CPROF = glances.cprof
profiling-gprof: ## Callgraph profiling (need "apt install graphviz")
	$(DISPLAY-BANNER)
	$(PYTHON) -m cProfile -o $(CPROF) run-venv.py -C $(CONF) --stop-after $(TIMES)
	$(venv_full)/gprof2dot -f pstats $(CPROF) | dot -Tsvg -o $(OUT_DIR)/glances-cgraph.svg
	rm -f $(CPROF)

profiling-pyinstrument: ## PyInstrument profiling
	$(DISPLAY-BANNER)
	$(PIP) install pyinstrument
	$(PYTHON) -m pyinstrument -r html -o $(OUT_DIR)/glances-pyinstrument.html -m glances -C $(CONF) --stop-after $(TIMES)

profiling-pyspy: ## Flame profiling
	$(DISPLAY-BANNER)
	$(venv_full)/py-spy record -o $(OUT_DIR)/glances-flame.svg -d 60 -s -- $(PYTHON) run-venv.py -C $(CONF) --stop-after $(TIMES)

profiling: profiling-gprof profiling-pyinstrument profiling-pyspy ## Profiling of the Glances software

trace-malloc: ## Trace the malloc() calls
	@echo "Malloc test is running, please wait ~30 secondes..."
	$(PYTHON) -m glances -C $(CONF) --trace-malloc --stop-after 15 --quiet

memory-leak: ## Profile memory leaks
	$(PYTHON) -m glances -C $(CONF) --memory-leak

memory-profiling: TIMES = 2400
memory-profiling: PROFILE = mprofile_*.dat
memory-profiling: OUT_DIR = docs/_static
memory-profiling: ## Profile memory usage
	@echo "It's a very long test (~4 hours)..."
	rm -f $(PROFILE)
	@echo "1/2 - Start memory profiling with the history option enable"
	$(venv_full)/mprof run -T 1 -C run-venv.py -C $(CONF) --stop-after $(TIMES) --quiet
	$(venv_full)/mprof plot --output $(OUT_DIR)/glances-memory-profiling-with-history.png
	rm -f $(PROFILE)
	@echo "2/2 - Start memory profiling with the history option disable"
	$(venv_full)/mprof run -T 1 -C run-venv.py -C $(CONF) --disable-history --stop-after $(TIMES) --quiet
	$(venv_full)/mprof plot --output $(OUT_DIR)/glances-memory-profiling-without-history.png
	rm -f $(PROFILE)

# Trivy installation: https://aquasecurity.github.io/trivy/latest/getting-started/installation/
trivy: ## Run Trivy to find vulnerabilities in container images
	trivy fs .

# ===================================================================
# Docs
# ===================================================================

docs: ## Create the documentation
	$(PYTHON) -m glances -C $(CONF) --api-doc > ./docs/api.rst
	cd docs && ./build.sh && cd ..

docs-server: docs ## Start a Web server to serve the documentation
	(sleep 2 && sensible-browser "http://localhost:$(PORT)") &
	cd docs/_build/html/ && ../../../venv/bin/python -m http.server $(PORT)

release-note: ## Generate release note
	git --no-pager log $(LASTTAG)..HEAD --first-parent --pretty=format:"* %s"
	@echo "\n"
	git --no-pager shortlog -s -n $(LASTTAG)..HEAD

install: ## Open a Web Browser to the installation procedure
	sensible-browser "https://github.com/nicolargo/glances#installation"

# ===================================================================
# WebUI
# Follow ./glances/outputs/static/README.md for more information
# ===================================================================

webui webui%: DIR = glances/outputs/static/

webui: ## Build the Web UI
	$(PYTHON) -c 'import json; from glances.outputs.glances_curses import _GlancesCurses; print(json.dumps({ "leftMenu": [p for p in _GlancesCurses._left_sidebar if p != "now"]}, indent=4))' > ./glances/outputs/static/js/uiconfig.json
	cd $(DIR) && npm ci && npm run build

webui-audit: ## Audit the Web UI
	cd $(DIR) && npm audit

webui-audit-fix: ## Fix audit the Web UI
	cd $(DIR) && npm audit fix && npm ci && npm run build

# ===================================================================
# Packaging
# ===================================================================

flatpak: venv-upgrade ## Generate FlatPack JSON file
	git clone https://github.com/flatpak/flatpak-builder-tools.git
	$(PYTHON) ./flatpak-builder-tools/pip/flatpak-pip-generator glances
	rm -rf ./flatpak-builder-tools
	@echo "Now follow: https://github.com/flathub/flathub/wiki/App-Submission"

# Snap package is automatically build on the Snapcraft.io platform
# https://snapcraft.io/glances
# But you can try an offline build with the following command
snapcraft:
	snapcraft

# ===================================================================
# Docker
# Need Docker Buildx package (apt install docker-buildx on Ubuntu)
# ===================================================================

define MAKE_DOCKER_BUILD_RULES
$($(DISTRO)_images): docker-$(DISTRO)-%: docker-files/$(DISTRO).Dockerfile
	$(DOCKER_BUILD) --target $$* -f $$< -t glances:local-$(DISTRO)-$$* .
endef

$(foreach DISTRO,$(DISTROS),$(eval $(MAKE_DOCKER_BUILD_RULES)))

docker: docker-alpine docker-ubuntu ## Generate local docker images

docker-alpine: $(alpine_images) ## Generate local docker images (Alpine)
docker-ubuntu: $(ubuntu_images) ## Generate local docker images (Ubuntu)

docker-alpine-full: ## Generate local docker image (Alpine full)
docker-alpine-minimal: ## Generate local docker image (Alpine minimal)
docker-alpine-dev: ## Generate local docker image (Alpine dev)
docker-ubuntu-full: ## Generate local docker image (Ubuntu full)
docker-ubuntu-minimal: ## Generate local docker image (Ubuntu minimal)
docker-ubuntu-dev: ## Generate local docker image (Ubuntu dev)

# ===================================================================
# Run
# ===================================================================

run: ## Start Glances in console mode (also called standalone)
	$(PYTHON) -m glances -C $(CONF)

run-debug: ## Start Glances in debug console mode (also called standalone)
	$(PYTHON) -m glances -C $(CONF) -d

run-local-conf: ## Start Glances in console mode with the system conf file
	$(PYTHON) -m glances

run-local-conf-hide-public: ## Start Glances in console mode with the system conf file and hide public information
	$(PYTHON) -m glances --hide-public-info

run-min: ## Start minimal Glances in console mode (also called standalone)
	$(venv_min)/python -m glances -C $(CONF)

run-min-debug: ## Start minimal Glances in debug console mode (also called standalone)
	$(venv_min)/python -m glances -C $(CONF) -d

run-min-local-conf: ## Start minimal Glances in console mode with the system conf file
	$(venv_min)/python -m glances

run-like-htop: ## Start Glances with the same features than Htop
	$(venv_min)/python -m glances --disable-plugin network,ports,wifi,connections,diskio,fs,irq,folders,raid,smart,sensors,vms,containers,ip,amps --disable-left-sidebar

$(DOCKER_RUNTIMES): run-docker-%:
	$(DOCKER_RUN) $(DOCKER_OPTS) $(DOCKER_SOCKS) -it glances:local-$*

run-docker-alpine-minimal: ## Start Glances Alpine Docker minimal in console mode
run-docker-alpine-full: ## Start Glances Alpine Docker full in console mode
run-docker-alpine-dev: ## Start Glances Alpine Docker dev in console mode
run-docker-ubuntu-minimal: ## Start Glances Ubuntu Docker minimal in console mode
run-docker-ubuntu-full: ## Start Glances Ubuntu Docker full in console mode
run-docker-ubuntu-dev: ## Start Glances Ubuntu Docker dev in console mode

run-webserver: ## Start Glances in Web server mode

=== requirements.txt ===
defusedxml
packaging
psutil>=5.6.7
windows-curses; platform_system == 'Windows'

=== debian/changelog ===
glances (4.3.1+dfsg-1) unstable; urgency=medium

  * New upstream release
  * debian/control
    + Bump to Standards-Version 4.7.2 (no changes needed)
  * debian/patches
    + Refresh 008_fix_lintian_warnings_in_manpage.diff patch

 -- Daniel Echeverri <epsilon@debian.org>  Fri, 28 Mar 2025 19:17:28 -0500

=== debian/control ===
Source: glances
Section: utils
Priority: optional
Maintainer: Daniel Echeverri <epsilon@debian.org>
Uploaders: Sebastien Badia <sbadia@debian.org>
Build-Depends: debhelper-compat (= 13),
               dh-python,
               python3-all,
               python3-psutil,
               python3-setuptools,
               python3-sphinx,
	       python3-defusedxml,
	       python3-sphinx-rtd-theme,
               python3-ujson,
               python3-orjson,
               pybuild-plugin-pyproject
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/debian/glances
Vcs-Git: https://salsa.debian.org/debian/glances.git
Homepage: https://github.com/nicolargo/glances
Rules-Requires-Root: no

Package: glances
Architecture: all
Depends: adduser,
         sysvinit-utils (>= 3.05-4~),
         python3-orjson,
         python3-fastapi,
         ${misc:Depends},
         ${python3:Depends}
Recommends: lm-sensors,
            python3-docker,
            python3-influxdb,
            python3-matplotlib,
            python3-netifaces,
            python3-pysnmp4,
            python3-pystache,
            python-fastapi,
            python3-uvicorn,
            python3-jinja2
Pre-Depends: ${misc:Pre-Depends}
Suggests: glances-doc, python3-pynvml, python3-paho-mqtt
Description: Curses-based monitoring tool
 Glances is a curses-based monitoring tool for GNU/Linux or BSD OS.
 Glances uses the PsUtil library to get information from your system.
 .
 It monitors CPU, load, memory, network bandwidth, disk I/O, disk use, process.

Package: glances-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: fonts-font-awesome,
         fonts-lato,
         fonts-roboto-slab,
         libjs-jquery,
         libjs-underscore,
	 libjs-sphinxdoc,
         node-html5shiv,
         ${misc:Depends},
	 ${sphinxdoc:Depends}
Suggests: glances
Breaks: glances (<< 2.5.1-1)
Replaces: glances (<< 2.5.1-1)
Description: Documentation for glances Curses-based monitoring tool
 This package provides all information about glances and how to use it
 Glances is  a cross-platform curses-based monitoring tool which aims
 to present a maximum of information in a minimum of space, ideally to
 fit in a classical 80x24 terminal or higher to have additional information.
 Also work in client/server mode. Remote monitoring could be done via terminal
 or web interface

## glances 4.3.3%2Bdfsg

=== docs/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = ../venv/bin/sphinx-build
PAPER         =
BUILDDIR      = _build

# User-friendly check for sphinx-build
ifeq ($(shell which $(SPHINXBUILD) >/dev/null 2>&1; echo $$?), 1)
$(error The '$(SPHINXBUILD)' command was not found. Make sure you have Sphinx installed, then set the SPHINXBUILD environment variable to point to the full path of the '$(SPHINXBUILD)' executable. Alternatively you can add the directory with the executable to your PATH. If you don't have Sphinx installed, grab it from http://sphinx-doc.org/)
endif

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help
help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  applehelp  to make an Apple Help Book"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  latexpdfja to make LaTeX files and run them through platex/dvipdfmx"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  xml        to make Docutils-native XML files"
	@echo "  pseudoxml  to make pseudoxml-XML files for display purposes"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"
	@echo "  coverage   to run coverage check of the documentation (if enabled)"

.PHONY: clean
clean:
	rm -rf $(BUILDDIR)/*

.PHONY: html
html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

.PHONY: dirhtml
dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

.PHONY: singlehtml
singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

.PHONY: pickle
pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

.PHONY: json
json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

.PHONY: htmlhelp
htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

.PHONY: qthelp
qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/Glances.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/Glances.qhc"

.PHONY: applehelp
applehelp:
	$(SPHINXBUILD) -b applehelp $(ALLSPHINXOPTS) $(BUILDDIR)/applehelp
	@echo
	@echo "Build finished. The help book is in $(BUILDDIR)/applehelp."
	@echo "N.B. You won't be able to view it unless you put it in" \
	      "~/Library/Documentation/Help or install it in your application" \
	      "bundle."

.PHONY: devhelp
devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/Glances"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/Glances"
	@echo "# devhelp"

.PHONY: epub
epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

.PHONY: latex
latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

.PHONY: latexpdf
latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

.PHONY: latexpdfja
latexpdfja:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through platex and dvipdfmx..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf-ja
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

.PHONY: text
text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

.PHONY: man
man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."
	rm -f man/*
	cp $(BUILDDIR)/man/* man/
	@echo "The manual pages have been copied in ./man."

.PHONY: texinfo
texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

.PHONY: info
info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

.PHONY: gettext
gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

.PHONY: changes
changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

.PHONY: linkcheck
linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

.PHONY: doctest
doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

.PHONY: coverage
coverage:
	$(SPHINXBUILD) -b coverage $(ALLSPHINXOPTS) $(BUILDDIR)/coverage
	@echo "Testing of coverage in the sources finished, look at the " \
	      "results in $(BUILDDIR)/coverage/python.txt."

.PHONY: xml
xml:
	$(SPHINXBUILD) -b xml $(ALLSPHINXOPTS) $(BUILDDIR)/xml
	@echo
	@echo "Build finished. The XML files are in $(BUILDDIR)/xml."

.PHONY: pseudoxml
pseudoxml:
	$(SPHINXBUILD) -b pseudoxml $(ALLSPHINXOPTS) $(BUILDDIR)/pseudoxml
	@echo
	@echo "Build finished. The pseudo-XML files are in $(BUILDDIR)/pseudoxml."

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,8 @@
 	       python3-sphinx-rtd-theme,
                python3-ujson,
                python3-orjson,
-               pybuild-plugin-pyproject
+               pybuild-plugin-pyproject,
+               bash-completion
 Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/debian/glances
 Vcs-Git: https://salsa.debian.org/debian/glances.git

## glances 4.3.3+dfsg

=== Makefile ===
--- 
+++ 
@@ -114,6 +114,23 @@
 test-min-with-upgrade: venv-min-upgrade ## Upgrade deps and run unit tests in minimal environment
 	$(venv_min)/python -m pytest tests/test_core.py
 
+test-export-csv: ## Run interface tests with CSV
+	/bin/bash ./tests/test_export_csv.sh
+
+test-export-json: ## Run interface tests with JSON
+	/bin/bash ./tests/test_export_json.sh
+
+test-export-influxdb-v1: ## Run interface tests with InfluxDB version 1 (Legacy)
+	/bin/bash ./tests/test_export_influxdb_v1.sh
+
+test-export-influxdb-v3: ## Run interface tests with InfluxDB version 3 (Core)
+	/bin/bash ./tests/test_export_influxdb_v3.sh
+
+test-export-timescaledb: ## Run interface tests with TimescaleDB
+	/bin/bash ./tests/test_export_timescaledb.sh
+
+test-export: test-export-csv test-export-json test-export-influxdb-v1 test-export-influxdb-v3 test-export-timescaledb## Tests all exports
+
 # ===================================================================
 # Linters, profilers and cyber security
 # ===================================================================
@@ -123,6 +140,9 @@
 
 lint: ## Lint the code.
 	$(venv_full)/python -m ruff check . --fix
+
+lint-readme: ## Lint the main README.rst file
+	$(venv_full)/python -m rstcheck README.rst
 
 codespell: ## Run codespell to fix common misspellings in text files
 	$(venv_full)/codespell -S .git,./docs/_build,./Glances.egg-info,./venv*,./glances/outputs,*.svg -L hart,bu,te,statics -w
@@ -188,6 +208,7 @@
 # ===================================================================
 
 docs: ## Create the documentation
+	$(PYTHON) ./generate_openapi.py
 	$(PYTHON) -m glances -C $(CONF) --api-doc > ./docs/api.rst
 	cd docs && ./build.sh && cd ..
 
@@ -219,6 +240,9 @@
 
 webui-audit-fix: ## Fix audit the Web UI
 	cd $(DIR) && npm audit fix && npm ci && npm run build
+
+webui-update: ## Update JS dependencies
+	cd $(DIR) && npm update --save && npm ci && npm run build
 
 # ===================================================================
 # Packaging
@@ -283,19 +307,3 @@
 	$(venv_min)/python -m glances -C $(CONF) -d
 
 run-min-local-conf: ## Start minimal Glances in console mode with the system conf file
-	$(venv_min)/python -m glances
-
-run-like-htop: ## Start Glances with the same features than Htop
-	$(venv_min)/python -m glances --disable-plugin network,ports,wifi,connections,diskio,fs,irq,folders,raid,smart,sensors,vms,containers,ip,amps --disable-left-sidebar
-
-$(DOCKER_RUNTIMES): run-docker-%:
-	$(DOCKER_RUN) $(DOCKER_OPTS) $(DOCKER_SOCKS) -it glances:local-$*
-
-run-docker-alpine-minimal: ## Start Glances Alpine Docker minimal in console mode
-run-docker-alpine-full: ## Start Glances Alpine Docker full in console mode
-run-docker-alpine-dev: ## Start Glances Alpine Docker dev in console mode
-run-docker-ubuntu-minimal: ## Start Glances Ubuntu Docker minimal in console mode
-run-docker-ubuntu-full: ## Start Glances Ubuntu Docker full in console mode
-run-docker-ubuntu-dev: ## Start Glances Ubuntu Docker dev in console mode
-
-run-webserver: ## Start Glances in Web server mode

=== requirements.txt ===
defusedxml
packaging
psutil>=5.6.7
shtab; platform_system != 'Windows'
windows-curses; platform_system == 'Windows'

=== debian/changelog ===
glances (4.3.3+dfsg-1) unstable; urgency=medium

  * New upstream version 4.3.3+dfsg
  * debian/control
    + Add bash-completion in B-D
  * debian/glances.postinst
    + Add function to generate bash completion
  * debian/glances.postrm
    + Remove bash completion file in purge process
  * debian/patches
    + Refresh 004_disable-pypi.patch
    + Refresh 006_indicate_user_webserver_static_files_not_included.patch
    + Refresh 008_fix_lintian_warnings_in_manpage.diff patch
  * debian/source/lintian-overrides
    + Add new lintian overrides

 -- Daniel Echeverri <epsilon@debian.org>  Sat, 30 Aug 2025 20:17:27 -0500

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export PYBUILD_NAME=glances

%:
	dh $@ --with python3,sphinxdoc --buildsystem=pybuild


# Split package and documentation
override_dh_sphinxdoc:
	python3 -m sphinx -b html -d debian/tmp/doctrees docs \
		debian/glances-doc/usr/share/doc/glances/html
	# Fonts
	rm -rf $(CURDIR)/debian/glances-doc/usr/share/doc/glances/html/_static/fonts/Lato-*
	rm -rf $(CURDIR)/debian/glances-doc/usr/share/doc/glances/html/_static/fonts/RobotoSlab-*
	rm -rf $(CURDIR)/debian/glances-doc/usr/share/doc/glances/html/_static/fonts/fontawesome-*

override_dh_missing:
	rm -rf debian/tmp/doctrees
	dh_missing --fail-missing

# Split package and documentation
override_dh_auto_install:
	dh_auto_install --destdir $(CURDIR)/debian/glances
	rm -f $(CURDIR)/debian/glances/usr/share/doc/glances/html/_static/jquery.js
	rm -f $(CURDIR)/debian/glances/usr/share/doc/glances/html/_static/underscore.js
	rm -f $(CURDIR)/debian/glances/usr/share/doc/glances/html/_static/doctools.js
	rm -f $(CURDIR)/debian/glances/usr/share/doc/glances/html/_static/language_data.js
	rm -f $(CURDIR)/debian/glances/usr/share/doc/glances/html/_static/searchtools.js
	rm -f $(CURDIR)/debian/glances/usr/share/doc/glances/html/_static/js/html5shiv-printshiv.min.js
	rm -f $(CURDIR)/debian/glances/usr/share/doc/glances/html/_static/js/html5shiv.min.js
	rm -f $(CURDIR)/debian/glances/usr/lib/python3/dist-packages/glances/outputs/static/public/images/glances.png
	rm -f $(CURDIR)/debian/glances/usr/lib/python3/dist-packages/glances/outputs/static/images/glances.png
	rm -f $(CURDIR)/debian/glances/usr/lib/python*/dist-packages/glances/outputs/static/README.md
	rm -f $(CURDIR)/debian/glances/usr/lib/python*/dist-packages/glances/outputs/static/.eslintrc.js
	rm -f $(CURDIR)/debian/glances/usr/lib/python*/dist-packages/glances/outputs/static/.gitignore

# Overriding test to prevent FTBS (cf. #733168) http://bugs.debian.org/733168
# disable tests as they require /etc/mtab and fail in chroots
override_dh_auto_test:

# Fix lintian warning (duplicates files Copying, News; and remove authors, glances.conf)
override_dh_installdocs:
	set -e && for docs in COPYING AUTHORS NEWS glances.conf; do \
                rm -f $(CURDIR)/debian/glances/usr/share/doc/glances/$$docs ; \
        done
	dh_installdocs

override_dh_auto_clean:
	rm -rf ./Glances.egg-info
	dh_auto_clean

=== debian/tests/control ===
Tests: install
Depends: @, curl
Restrictions: needs-root,allow-stderr

=== debian/watch ===
version=4
opts=repacksuffix=+dfsg,\
  repack,compression=gz,\
  dversionmangle=s/\+dfsg\d*$//,oversionmangle=s/$/+dfsg/,\
  uversionmangle=s/_/./;s/RC/~rc/,filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/glances-$1\.tar\.gz/ \
  https://github.com/nicolargo/glances/tags .*/v?(\d\S+)\.tar\.gz
